import { IVisitor } from './IVisitor';
import { Node } from './parse-tree';
/**
 * @stability stable
 */
export interface KvMap {
    [key: string]: number;
}
/**
 * @stability stable
 */
export declare class PrintTreeStructureVisitor implements IVisitor {
    /**
     * @stability stable
     */
    indent: string;
    /**
     * @stability stable
     */
    indentLevel: number;
    /**
     * @stability stable
     */
    lastIndentLevel: number;
    /**
     * @stability stable
     */
    output: string;
    /**
     * @stability stable
     */
    knownChildrenSeen: KvMap;
    /**
     * @stability stable
     */
    preVisit(node: Node): void;
    /**
     * @stability stable
     */
    visit(node: Node): void;
    /**
     * @stability stable
     */
    postVisit(node: Node): void;
    /**
     * @stability stable
     */
    makeIndent(): void;
}
